    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.text.CollationKey

    java.lang.Object
       |
       +----java.text.CollationKey

public final class CollationKey
extends Object

A `CollationKey` represents a `String` under the rules of a specific `Collator` object. Comparing two `CollationKey`s returns the relative order of the `String`s they represent. Using `CollationKey`s to compare `String`s is generally faster than using `Collator.compare`. Thus, when the `String`s must be compared multiple times, for example when sorting a list of `String`s. It's more efficient to use `CollationKey`s.

You can not create `CollationKey`s directly. Rather, generate them by calling `Collator.getCollationKey`. You can only compare `CollationKey`s generated from the same `Collator` object.

Generating a `CollationKey` for a `String` involves examining the entire `String` and converting it to series of bits that can be compared bitwise. This allows fast comparisons once the keys are generated. The cost of generating keys is recouped in faster comparisons when `String`s need to be compared many times. On the other hand, the result of a comparison is often determined by the first couple of characters of each `String`. `Collator.compare` examines only as many characters as it needs which allows it to be faster when doing single comparisons.

The following example shows how `CollationKey`s might be used to sort a list of `String`s.

>      // Create an array of CollationKeys for the Strings to be sorted.
>      Collator myCollator = Collator.getInstance();
>      CollationKey[] keys = new CollationKey[3];
>      keys[0] = myCollator.getCollationKey("Tom");
>      keys[1] = myCollator.getCollationKey("Dick");
>      keys[2] = myCollator.getCollationKey("Harry");
>      sort( keys );

>      //...

>      // Inside body of sort routine, compare keys this way
>      if( keys[i].compareTo( keys[j] ) > 0 )
>         // swap keys[i] and keys[j]

>      //...

>      // Finally, when we've returned from sort.
>      System.out.println( keys[0].getSourceString() );
>      System.out.println( keys[1].getSourceString() );
>      System.out.println( keys[2].getSourceString() );

See Also:
  Collator, RuleBasedCollator

##

compareTo(CollationKey)
  Compare this CollationKey to the target CollationKey.
equals(Object)
  Compare this CollationKey and the target CollationKey for equality.
getSourceString()
  Returns the String that this CollationKey represents.
hashCode()
  Creates a hash code for this CollationKey.
toByteArray()
  Converts the CollationKey to a sequence of bits.

##

compareTo

     public int compareTo(CollationKey target)

  Compare this CollationKey to the target CollationKey. The collation rules of the Collator object which created these keys are applied. Note: CollationKeys created by different Collators can not be compared.

  Parameters:
    target - target CollationKey
  Returns:
    Returns an integer value. Value is less than zero if this is less than target, value is zero if this and target are equal and value is greater than zero if this is greater than target.
  See Also:
    compare

equals

     public boolean equals(Object target)

  Compare this CollationKey and the target CollationKey for equality. The collation rules of the Collator object which created these keys are applied. Note: CollationKeys created by different Collators can not be compared.

  Parameters:
    target - the CollationKey to compare to.
  Returns:
    Returns true if two objects are equal, false otherwise.
  Overrides:
    equals in class Object

hashCode

     public int hashCode()

  Creates a hash code for this CollationKey. The hash value is calculated on the key itself, not the String from which the key was created. Thus if x and y are CollationKeys, then x.hashCode(x) == y.hashCode() if x.equals(y) is true. This allows language-sensitive comparison in a hash table. See the CollatinKey class description for an example.

  Returns:
    the hash value based on the string's collation order.
  Overrides:
    hashCode in class Object

getSourceString

     public String getSourceString()

  Returns the String that this CollationKey represents.

toByteArray

     public byte[] toByteArray()

  Converts the CollationKey to a sequence of bits. If two CollationKeys could be legitimately compared, then one could compare the byte arrays for each of those keys to obtain the same result. Byte arrays are organized most significant byte first.

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.